## fcidecomp 2.1.1

=== debian/changelog ===
fcidecomp (2.1.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1091480)

 -- Enrico Zini <enrico@debian.org>  Fri, 27 Dec 2024 16:24:14 +0100
