## fcidecomp 2.1.1%2Bdeb1

=== debian/watch ===
# See uscan(1) for format.

# Compulsory line, this is a version 4 file.
version=4

opts="mode=git" https://gitlab.eumetsat.int/open-source/data-tailor-plugins/fcidecomp.git \
    refs/tags/([\d\.]+)
