=== debian/changelog ===
fcidecomp (2.1.1+deb1-1) unstable; urgency=medium

  * Aligned with upstream tag 2.1.1
  * Bump minimum cmake compat to 3.5 to build with cmake4
  * Added README.source to explain what is going on

 -- Enrico Zini <enrico@debian.org>  Sun, 28 Sep 2025 12:33:35 +0200
