=== debian/control ===
Source: fcidecomp
Section: libs
Priority: optional
Maintainer: Enrico Zini <enrico@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.15),
 libhdf5-dev,
 libcharls-dev,
Standards-Version: 4.6.2
Homepage: https://gitlab.eumetsat.int/open-source/data-tailor-plugins/fcidecomp
Vcs-Browser: https://salsa.debian.org/science-team/fcidecomp
Vcs-Git: https://salsa.debian.org/science-team/fcidecomp.git

Package: libfcidecomp-jpegls-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libfcidecomp-jpegls1 (= ${binary:Version}),
 ${misc:Depends},
Description: fcicomp interface to charls JPEG-LS library (development files)
 This library provides an interface to the charls library for use by the
 fcicomp-H5Zjpegls plugin

Package: libfcidecomp-jpegls1
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: fcicomp interface to charls JPEG-LS library
 This library provides an interface to the charls library for use by the
 fcicomp-H5Zjpegls plugin

Package: libh5z-jpegls-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 hdf5-filter-plugin-fcidecomp-serial (= ${binary:Version}),
 ${misc:Depends},
Description: HDF5 JPEG-LS compression-decompression filter (development files)
 This is the development interface to the JPEG-LS filter plugin for HDF5

Package: hdf5-filter-plugin-fcidecomp-serial
Provides: hdf5-filter-plugin-fcidecomp
Conflicts: hdf5-filter-plugin-fcidecomp
Replaces: hdf5-filter-plugin-fcidecomp
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: HDF5 JPEG-LS compression-decompression filter
 This is a HDF5 filter plugin that enables decompression of JEPG-LS HDF5/NetCDF
 file.
 .
 This filter plugin is required to access EUMETSAT Meteosat Third Generation
 (MTG) NetCDF files.
