=== debian/tests/control ===
Test-Command: python3 -c 'import sys, h5py; sys.exit(not h5py.h5z.filter_avail(32018))'
Depends: python3, python3-h5py, @
Restrictions: allow-stderr
